let input;

function setup() {
  createCanvas(400, 400);
  input = createElement("textarea");
  input.size(400, 100);
  input.elt.placeholder = "Enter JSON string of the form:\n" +
    "{\n" +
    "  \"cities\": [[100.8, 50.2], ...],\n" +
    "  \"pathIndices\": [1, 3, 2, 0,...],\n" +
    "  \"score\": 123.4\n" +
    "}";
  input.input(process_input);
}

function process_input() {
  let {cities, pathIndices, score} = JSON.parse(input.value());
  let path = pathIndices.map(index => cities[index]);
  drawPath(path);
  checkScore(path, score);
}

function drawPath(path) {
  background(0);
  stroke(255);
  strokeWeight(4);
  noFill();
  beginShape();
  for (let [x, y] of path) {
    vertex(x, y);
    ellipse(x, y, 4, 4);
  }
  endShape(CLOSE);
}

function checkScore(path, score) {
  let pathLength = 0;
  for (let i = 0; i < path.length; i++) {
    let [x0, y0] = path[i];
    let [x1, y1] = path[(i+1) % path.length];
    pathLength += sqrt((x1-x0)**2 + (y1-y0)**2);
  }

  console.log("Actual path length:  ", pathLength);
  console.log("Expected path length:", score);
}
